close all
N=10;
[bvp,info]=fc_vfemp1.samples.setBVPCondenser2D01(N,2);
U=bvp.solve();

Th=bvp.Th;
options=fc_tools.graphics.DisplayFigures('nfig',4); % To present 'nicely' the 4 figures
figure(1)
Th.plotmesh('legend',true)
axis equal
set(legend(),options.legend{:})
set(gca,options.axes{:})

figure(2)
Th.plotmesh('color',[0.8,0.8,0.8])
hold on
Th.plotmesh('d',1,'legend',true)
axis equal
set(legend(),options.legend{:})

figure(3)
Th.plot(U)
axis off,axis image
set(colorbar(),options.colorbar{:});
shading interp
title('Condenser2D[01], P1-FEM solution',options.title{:})

figure(4)
Th.plotmesh('d',1,'color','k')
hold on
[~,~,cax]=Th.plotiso(U,'niso',20,'isocolorbar',true,'format','%.3f');
set(cax,options.colorbar{:});
axis off,axis image
title('Condenser2D[01], P1-FEM solution - isolines',options.title{:})

